Package tigase.xmpp.impl

# Class SaslAuth2

java.lang.Object
tigase.xmpp.XMPPProcessor
tigase.xmpp.impl.AbstractAuthPreprocessor
tigase.xmpp.impl.SaslAuthAbstract
tigase.xmpp.impl.SaslAuth2

All Implemented Interfaces:
  `Comparable<XMPPImplIfc>`, `XMPPImplIfc`, `XMPPPreprocessorIfc`, `XMPPProcessorConcurrencyAwareIfc`, `XMPPProcessorIfc`

@Bean(name="urn:xmpp:sasl:2", parent=SessionManager.class, active=false) public class SaslAuth2 extends SaslAuthAbstract implements XMPPProcessorIfc

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static enum`
  `SaslAuth2.ElementType`
  `static interface`
  `SaslAuth2.Inline`
  `static class`
  `SaslAuth2.UserAgent`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ID`
  `protected static final String`
  `SASL_FEATURES_KEY`
  `protected static final String`
  `USER_AGENT_KEY`

  ### Fields inherited from class tigase.xmpp.impl.SaslAuthAbstract

  `ALLOWED_SASL_MECHANISMS_KEY, props, SASL_SERVER_KEY, saslProvider`

  ### Fields inherited from class tigase.xmpp.XMPPProcessor

  `ALL_NAMES, ALL_PATHS, cmpInfo`

  ### Fields inherited from interface tigase.xmpp.XMPPImplIfc

  `CLIENT_XMLNS`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SaslAuth2()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected Element`
  `createReply(SaslAuth2.ElementType type, String cdata)`
  `List<SaslAuth2.Inline>`
  `getInlines()`
  `protected String`
  `getXmlns()`
  `String`
  `id()`
  Method `id` returns a unique ID of the plugin.
  `void`
  `process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings)`
  `protected void`
  `processSuccess(Packet packet, XMPPResourceConnection session, String challengeData, Queue<Packet> results)`
  `void`
  `setInlines(List<SaslAuth2.Inline> inlines)`
  `Element[]`
  `supDiscoFeatures(XMPPResourceConnection session)`
  Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request.
  `String[][]`
  `supElementNamePaths()`
  Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin.
  `String[]`
  `supNamespaces()`
  Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin.
  `Element[]`
  `supStreamFeatures(XMPPResourceConnection session)`
  Method `supStreamFeatures` returns an array of XML `Element`s with stream features which have to be returned to the client uppon request.

  ### Methods inherited from class tigase.xmpp.impl.SaslAuthAbstract

  `concurrentQueuesNo, createSaslErrorResponse, extractUserJid, onAuthFail, processSessionAlreadyAuthorized`

  ### Methods inherited from class tigase.xmpp.impl.AbstractAuthPreprocessor

  `addInvalidLogin, disableUser, getAllowMatchers, isBruteForceLockerEnabled, isLoginAllowedByBruteForceLocker, isPacketAllowed, preProcess, saveIntoBruteForceLocker, setAllowMatchers, setBruteForceLocker`

  ### Methods inherited from class tigase.xmpp.XMPPProcessor

  `canHandle, compareTo, getComponentInfo, getInstance, getQueueSize, getStatistics, getThreadsNo, init, supTypes, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.lang.Comparable

  `compareTo`

  ### Methods inherited from interface tigase.xmpp.XMPPImplIfc

  `canHandle, concurrentQueuesNo, getComponentInfo, getStatistics, init, supTypes`

- ## Field Details

  - ### ID

    public static final String ID
    See Also:
      - Constant Field Values

  - ### USER_AGENT_KEY

    protected static final String USER_AGENT_KEY
    See Also:
      - Constant Field Values

  - ### SASL_FEATURES_KEY

    protected static final String SASL_FEATURES_KEY
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### SaslAuth2

    public SaslAuth2()

- ## Method Details

  - ### id

    public String id()
    Description copied from interface: `XMPPImplIfc`
    Method `id` returns a unique ID of the plugin. Each plugin has own, unique ID which is used in the configuration file to determine whether it needs to be loaded or not. In most cases the ID can be equal to XMLNS of the packages processed by the plugin.
    Specified by:
      `id` in interface `XMPPImplIfc`
    Returns:
      a `String` value

  - ### supDiscoFeatures

    public Element[] supDiscoFeatures(XMPPResourceConnection session)
    Description copied from interface: `XMPPImplIfc`
    Method `supDiscoFeatures` returns an array of XML `Element`s with service discovery features which have to be returned to the client uppon request. Service discovery features returned by this method correspond to services supported by this plugin.
    Specified by:
      `supDiscoFeatures` in interface `XMPPImplIfc`
    Overrides:
      `supDiscoFeatures` in class `XMPPProcessor`
    Parameters:
      `session` - a `XMPPResourceConnection` value
    Returns:
      an `Element[]` value

  - ### supElementNamePaths

    public String[][] supElementNamePaths()
    Description copied from interface: `XMPPImplIfc`
    Method `supElementNamePaths` returns an array of element names in form of a full path to the XML element for stanzas which can be processed by this plugin. Each element name path corresponds to XMLNS returned in array by `supNamespaces()` method. The element path itself is represented by a String array with each path element as a separate String.
    Specified by:
      `supElementNamePaths` in interface `XMPPImplIfc`
    Overrides:
      `supElementNamePaths` in class `XMPPProcessor`
    Returns:
      a `String[][]` value is an array for element paths for which the plugin offers processing capabilities. Each path is in form of a String array in order to reduce parsing overhead.

  - ### supNamespaces

    public String[] supNamespaces()
    Description copied from interface: `XMPPImplIfc`
    Method `supNamespaces` returns an array of name-spaces for stanzas which can be processed by this plugin. Each namespace corresponds to element name returned in array by `supElemenets()` method.
    Specified by:
      `supNamespaces` in interface `XMPPImplIfc`
    Overrides:
      `supNamespaces` in class `XMPPProcessor`
    Returns:
      a `String[]` value

  - ### getInlines

    public List<SaslAuth2.Inline> getInlines()

  - ### setInlines

    public void setInlines(List<SaslAuth2.Inline> inlines)

  - ### supStreamFeatures

    public Element[] supStreamFeatures(XMPPResourceConnection session)
    Description copied from interface: `XMPPImplIfc`
    Method `supStreamFeatures` returns an array of XML `Element`s with stream features which have to be returned to the client uppon request. Stream features returned by this method correspond to features supported by this plugin.
    Specified by:
      `supStreamFeatures` in interface `XMPPImplIfc`
    Overrides:
      `supStreamFeatures` in class `XMPPProcessor`
    Parameters:
      `session` - a `XMPPResourceConnection` value
    Returns:
      an `Element[]` value

  - ### process

    public void process(Packet packet, XMPPResourceConnection session, NonAuthUserRepository repo, Queue<Packet> results, Map<String,Object> settings) throws XMPPException
    Specified by:
      `process` in interface `XMPPProcessorIfc`
    Parameters:
      `packet` - packet is which being processed. This parameter may never be null. Even though this is not immutable object it mustn't be altered. None of it's fields or attributes can be changed during processing.
      `session` - user session which keeps all the user session data and also gives an access to the user's repository data. It allows for storing information in a permanent storage or in memory only during the live of the online session. This parameter can be null if there is no online user session at the time of the packet processing.
      `repo` - this is a user data storage which is normally used when the user session (parameter above) is null. This is repository allows for a very restricted access only. It allows for storing some user private data (doesn't allow overwriting existing data) like messages for offline users and it also allows for reading user public data like VCard.
      `results` - this a collection with packets which have been generated as input packet processing results. Regardless a response to a user request is sent or the packet is forwarded to it's destination it is always required that a copy of the input packet is created and stored in the results queue.
      `settings` - this map keeps plugin specific settings loaded from the Tigase server configuration. In most cases it is unused, however if the plugin needs to access an external database that this is a way to pass database connection string to the plugin.
    Throws:
      `XMPPException`

  - ### processSuccess

    protected void processSuccess(Packet packet, XMPPResourceConnection session, String challengeData, Queue<Packet> results)
    Specified by:
      `processSuccess` in class `SaslAuthAbstract`

  - ### getXmlns

    protected String getXmlns()
    Specified by:
      `getXmlns` in class `SaslAuthAbstract`

  - ### createReply

    protected Element createReply(SaslAuth2.ElementType type, String cdata)